import { LocaleConfig } from '@forten/locale';
import { IAction, IContext } from 'overmind';
import { FunctionComponent as Comp } from 'react';
import styled from 'styled-components';
import { CodeEditorConfig } from './types.js';
export { styled, Comp };
export declare function css(strings: TemplateStringsArray, ...values: any[]): string;
export declare type Config = CodeEditorConfig & LocaleConfig;
export declare type Context = IContext<Config>;
export declare const theme: {};
export declare const useOvermind: () => {
    state: {
        codeEditor: {};
    } & {
        locale: {
            lang: string;
            locales: import("@forten/locale").Locales;
            sources: import("@forten/locale").LocalesByBlock;
            common: {
                [keyAndScope: string]: string;
            };
            translate: import("@forten/locale").Translate;
        };
    };
    actions: {
        codeEditor: {};
        hooks: {
            locale_set: (value: {
                lang: string;
            }) => Promise<boolean | void | undefined>;
        };
        locale: {
            readonly print: () => void;
            readonly printMissing: (value: string) => void;
            readonly set: (value: string) => void;
        };
    };
    effects: {};
    addMutationListener: (cb: import("proxy-state-tree").IMutationCallback) => () => void;
    reaction: import("overmind").IReaction<Config>;
};
export declare type Action<Input = void, Output = void> = IAction<Config, Input, Output>;
