/// <reference types="codemirror" />
import { CodeMirror } from './CodeMirror.js';
import { ScrubCode, TranspileCallback } from './types.js';
interface CMOptions {
    lucidity: EditorLucidityOptions;
}
interface CMEditor extends CodeMirror.Editor {
    options: CMOptions;
}
interface EditorLucidityOptions {
    scrubber: Scrubber;
    lock?: string;
    noscrub?: boolean;
    blockId?: string;
    cursorMarkCleared?: boolean;
    nosave?: boolean;
    lang?: string;
    source?: string;
    mode?: string;
    callbacks: Callbacks;
}
export interface Scrubber extends ScrubCode {
    init?: any;
}
export declare const compileCode: (source: string, done: TranspileCallback) => void;
export declare const scrubMark: (cm: CMEditor) => void;
export declare const sourceChanged: (cm: CMEditor, lang: string, source: string, blockId: string) => void;
export declare const saveSource: (cm: CMEditor) => void;
interface Callbacks {
    onSave?: (filename: string, source: string) => void;
    onBlur?: () => void;
    typecheck?: (filename: string, source: string) => void;
}
export declare const makeEditor: (elm: HTMLElement, source: string | undefined, lang: string, callbacks?: Callbacks | undefined, options?: {
    autofocus?: boolean;
    keyMap?: 'vim';
}) => any;
export {};
